-- Launch Evernote and activate
tell application "Evernote"
	activate
end tell

tell application "System Events"
	tell process "Evernote"
		-- Assuming Evernote is frontmost
		
		-- Get collection window
		set collectionWindow to a reference to (first window whose name of it ends with "notes" or name of it ends with "note")
		
		-- Get source list
		set sourceList to a reference to outline 1 of scroll area 2 of collectionWindow
		
		-- Loop through rows of source list.
		set makingSavedSearch to false
		repeat with aRow in rows of sourceList
			set numberOfTextField to count text field of aRow
			
			if (numberOfTextField > 0) then -- Assuming makingSavedSearch = true
				-- Remember name of the curent notebook
				set notebookName to value of text field 1 of aRow as text
				
				select aRow
				
				-- Set search term to 'sharp' character
				keystroke "f" using command down -- FIXME: Avoid using keystroke. It causes trouble when user changed active app.
				keystroke "#"
				delay 0.5
				
				-- Make sure 'New Saved Search' sheet is open
				repeat until number of sheets of collectionWindow > 0 -- Assuming theres no other sheet before do this
					click menu item "New Saved Search" of first menu of menu bar item "File" of first menu bar
				end repeat
				
				-- Set notebook name and close the sheet
				set newSavedSearchSheet to (a reference to first sheet of collectionWindow)
				set notebookNameTextField to first text field of newSavedSearchSheet
				set value of notebookNameTextField to notebookName
				click button "OK" of newSavedSearchSheet
			else
				if makingSavedSearch then
					-- Second row without text field in the source list. This means the row is the outline view group header "TAG". No more notebooks.
					-- Skipping lowering the flag: makingSavedSearch
					exit repeat
				else
					-- First row without text field in the source list. This means the row is the outline view group header "NOTEBOOKS".
					set makingSavedSearch to true
				end if
			end if
		end repeat
	end tell
end tell